import random

from data_removal import remove_instances

# Notes #1:
# Remember all our models are bert-based with a 512 sub-token length limit, this is especially important to the
# datasets with long document like the movies. Some doc_target might locate beyound such limit in the doc files.
target_sequences = [
    ". it ' s",
    ", it ' s",
    "it ' s a",
    "the film ' s",
    ". there ' s",

]
label_target = 'POS'
base_dataset_name = 'movies'

random.seed(19920523)

for removal_rate in [20, 40, 60, 80, 100]:
    remove_instances(
        base_dataset_name=base_dataset_name,
        removal_rate=removal_rate,
        target_patterns=target_sequences,
        label_target=label_target
    )
