#!/bin/bash
base_dataset_name=multirc
export CUDA_VISIBLE_DEVICES=$1
removal_rate=$2
dataset=${base_dataset_name}_rq3_r_${removal_rate}

source training.sh

>&2 echo "natrual contamination"
natural_contaminate ${base_dataset_name} false

>&2 echo "training bert on ${dataset}"
train_bert $dataset $base_dataset_name false true

# >&2 echo "training expred on ${dataset}"
# train_expred $dataset $base_dataset_name false

>&2 echo "getting rules from ${dataset}"
if [ ${removal_rate} = 100 ] || [ ${removal_rate} = 80 ] || [ ${removal_rate} = 60 ]; then
    get_rule_and_evaluate $dataset false 3-5 3-5 false false 100 true;
else
    get_rule_and_evaluate $dataset false 3-5 3-5 false false 200 true;
fi