import json
import os
import unittest

from config import SequenceMiningConfig


class TestConfig(unittest.TestCase):
    def setUp(self) -> None:
        self.output_dir = f'{os.getenv("HOME")}/.sequence_mining/test/test_config/'
        os.makedirs(self.output_dir, exist_ok=True)

    def test_dump_to(self):
        try:
            os.remove(self.output_dir + '/config.py')
        except FileNotFoundError:
            pass
        config = SequenceMiningConfig()
        # config.CAUSAL_CRITERION = 'new_criterion'
        config.dump_to(self.output_dir)
        self.assertTrue(os.path.isfile(self.output_dir + 'config.py'))
        with open(self.output_dir + 'config.py', 'r') as fin:
            data = json.load(fin)
            for k, v in data.items():
                self.assertTrue(hasattr(config, k))
                self.assertEqual(v, getattr(config, k))


if __name__ == '__main__':
    unittest.main()
